import numpy as np
import time

class FeatureExtractorKungFu:
	
	def __init__(self):
		self._prev_x = None
		self._current_x = None
		
	# this should be called at the start of the episode	
	def reset(self):
		self._prev_x = None	
	
	# the input I should be the observation from the atari engine and an image
	def compute_features(self,I):
		# first, preprocess image for kungfu -- in this case, crop
		I = I[98:165,1:160]
		
		# convert to a vector
		self._current_x = I.astype(np.float).ravel()
		
		# compute difference
		x = self._current_x - self._prev_x if self._prev_x is not None else np.zeros(D)
		
		# divide so values are between 0 and 1
		x = x / 255
		
		# store current as previous
		self._prev_x = self._current_x
		
		return x 
